# Danicoin

This is Danicoin, the best cryptocurrency out there.

## Building

There are currently no pre-built binaries available. To build Danicoin on an
Ubuntu machine, you first need to install some dependencies:

```
sudo apt install git build-essential cmake libboost-all-dev
```

You can then fetch the code and compile it like this:

```
git clone https://kumig.it/kumitterer/danicoin.git
cd danicoin
make
```

The binaries (you will primarily want to use danicoind and daniwallet) will be
placed into the "build/release/src" subdirectory of the danicoin source 
directory. You may want to move them to /usr/bin like this:

```
sudo install build/release/src/dani{coind,wallet,ct,miner,walletd} /usr/bin
```

## Usage

### danicoind

Danicoin's core component is the daemon, danicoind. It is responsible for 
keeping your copy of the blockchain in sync. Assuming you have installed it to 
/usr/bin as seen above, you can just fire it up like this:

```
danicoind
```

Please note that running it for the first time might take a while as the entire
blockchain will have to be downloaded.

danicoind should not require any configuration as such. By default, it will
store its data, including a full copy of the blockchain, in the ".danicoin" 
subdirectory of your user directory.

If you need to change any settings, you may pass them as arguments to danicoind
or write them to a configuration file. If a "danicoin.conf" file exists in the
data directory (~/.danicoin), its settings will be used by default.

You can find the arguments accepted by danicoind by executing:

```
danicoind --help
```

A sample configuration file can be found [in this repository](/danicoin.conf).

### daniwallet

The easiest way to create and manage Danicoin wallets is using daniwallet. To
create your first wallet, named "mywallet" in this example, execute:

```
daniwallet --generate-new-wallet mywallet
```

daniwallet will then ask you for a password and generate your new wallet. Two
files will be stored in your current working directory - mywallet.wallet and
mywallet.address. mywallet.wallet contains the actual wallet, mywallet.address
contains the wallet address you use to receive payments.

In order to use daniwallet with an existing wallet, navigate to the directory
containing your mywallet.wallet, then execute:

```
daniwallet --wallet-file mywallet
```

Once daniwallet is running, you can, for instance, type in "balance" and press
Enter to see your current balance. To transfer money to another wallet, you may
use the following command (replacing "recipient_address" with the actual address
of the receiving wallet and "amount" with the amount of Danicoin to send):

```
transfer 3 recipient_address amount
```

You can find out about the other commands using "help".

### daniminer

If you want to try and generate some Danicoin yourself, you may use the included
miner. Usage is fairly simple - if you don't have a good reason to modify the
default settings, just run (replacing "your_address" with the Danicoin address
which should receive the mining rewards):

```
daniminer --address your_address
```

If you want to play around with daniminer's settings, you may find all available
command line arguments by executing:

```
daniminer --help
```

## GUI wallet

A graphical frontend to Danicoin is available at [kumitterer/danicoinwallet]
(https://kumig.it/kumitterer/danicoinwallet).